#include <stdio.h>

int main(void) {
    int num = 10;         // Una variable entera
    int *ptr = &num;      // Un puntero que almacena la dirección de 'num'

    // 1. Mostrar el valor de la variable
    printf("Valor de num: %d\n", num);

    // 2. Mostrar la dirección de la variable
    printf("Dirección de num: %p\n", &num);

    // 3. Mostrar el valor almacenado en el puntero (dirección de num)
    printf("Valor almacenado en el puntero ptr: %p\n", ptr);

    // 4. Mostrar el valor apuntado por el puntero (contenido en la dirección apuntada)
    printf("Valor al que apunta ptr: %d\n", *ptr);

    // 5. Modificar el valor de la variable usando el puntero
    *ptr = 20;
    printf("Nuevo valor de num (modificado mediante ptr): %d\n", num);

    // 6. Usar un puntero doble (puntero a puntero)
    int **ptr2 = &ptr;
    printf("Valor almacenado en ptr2 (dirección de ptr): %p\n", ptr2);
    printf("Valor al que apunta ptr2 (contenido de ptr): %p\n", *ptr2);
    printf("Valor final al que apunta ptr2 (contenido de num): %d\n", **ptr2);

    return 0;
}
